#include "t_cpu.h"
#define M68000read_byte(x) m68000.bus(0,0,x,0)
#define M68000read_word(x) m68000.bus(0,1,x,0)
#define M68000read_long(x) m68000.bus(0,2,x,0)
#define M68000write_byte(x,y) m68000.bus(1,0,x,y)
#define M68000write_word(x,y) m68000.bus(1,1,x,y)
#define M68000write_long(x,y) m68000.bus(1,2,x,y)
#define read_byte(x) M68000read_byte(x)
#define read_word(x) M68000read_word(x)
#define read_long(x) M68000read_long(x)
#define write_byte(x,y) M68000write_byte(x,y)
#define write_word(x,y) M68000write_word(x,y)
#define write_long(x,y) M68000write_long(x,y)
#define busstat M68000busstat
#define COMPILE_CORE 10



typedef struct {
   unsigned int
        sreg:3,
       smode:3,
       dmode:3,
        dreg:3,
        size:2,
          op:2;
} opc2;

typedef struct {
   unsigned int
      mode1:3,
       reg1:3,
        reg:3,
       mode:3,
         op:4;
        
} opc4;

typedef struct { /* hrmmm don't forget cpu is backwords in 80x86 mem */
   unsigned int 
         reg:3,
        mode:3,
        size:2,
          op:8;
} opc8;

typedef struct {
   unsigned int    
          op:12,
          da:1,
         reg:3;
} opc12;

typedef struct {
   unsigned int
        disp:8,
         con:4,
          op:4;
 } opc4c;
 typedef struct {
    unsigned int
        reg1:3,
        mode:3,
         op2:3, 
         reg:3,
         op1:4;
} opc4ea;
typedef struct {
   unsigned int
        reg1:3,
        mode:3,
        size:1,
         op2:3,
          dr:1,
         op1:4;
 } opc4m;
typedef struct {
   unsigned int
         reg:3,
        mode:3,          
        size:1,
         op2:3,
          dr:1,
         op1:5;
} opc5;  
 
typedef union {
  short int decode;
  opc4  b4;
  opc4c b4c;
  opc8  b8; 
  opc12 b12;
  opc4ea b4ea;
  opc4m b4m;
  opc5  b5;
  opc2  b2;
} t_pipeline;


typedef struct {
   int d[8],a[8],pc; /* data[7], address[7], program counter */
   short int t1:1, /* although in the 68020 only, it makes for good */
             t0:1, /* debuging possibilities */
              s:1,
              m:1,
             na:1, /* an unused bit (I'll use it i guess :) */
              o:1,
            ipm:3,
            na2:3,  /* 3 unusued bits */   
              x:1,  /* from here below is standard 68k */
              n:1,
              z:1,
              v:1,
              c:1;
      unsigned int cycles;
} genst;

typedef struct {
   unsigned short int mask,op,cycles;
   int (*c)();
   char rawname[8];
} t_op;

typedef struct {
   unsigned short cycles;
      int (*c)();
} t_opc;
