#include <stdio.h>
#include "cpudef.h"
#include "core.h"
#include "ram.h"


unsigned long int nego( unsigned char size)
{
  switch(size)
  {
     case 0:
       return (unsigned long int)127;
     case 1:
       return (unsigned long int)32767;
     case 2:
       return (unsigned long int)2147483647;
  }
}        

        
int _tst(void)
{
    int x;
    gen.z=0;
    gen.n=0;
    x=get_ea(pipeline.b8.mode,pipeline.b8.reg,pipeline.b8.size,0);
    if(x == 0) gen.z=1;
    else if(x > (unsigned long int) nego(pipeline.b8.size)) gen.n=1;
    return 1;
}

void _bcc_jmpt(void)
{
    if(pipeline.b4c.disp == 0)
        gen.pc+=(signed long) read_word(gen.pc+2);
    else if(pipeline.b4c.disp == 0xff)
        gen.pc+=(signed long) read_long(gen.pc+2);
    else 
        gen.pc+=(signed long) pipeline.b4c.disp;    
    opdsp=0;
}

void _bcc_jmpf(void)
{
    if(pipeline.b4c.disp == 0)
        gen.pc+=4;
    else if(pipeline.b4c.disp == 0xff)
        gen.pc+=6;
    else 
        gen.pc+=2;    
    opdsp=0;
}



int _bcc(void)
{

   switch(pipeline.b4c.con)
   {
       case 0:
       {
         _bcc_jmpt();
         return 1;
       
       }
       case 4: /* Carry clear */
       {
          if(!gen.c) _bcc_jmpt();
          else _bcc_jmpf();
          return 1;  
       }   
       case 5: /* carry set */
       {
          if(gen.c) _bcc_jmpt();
          else _bcc_jmpf();  
          return 1;
       }
       case 6: /* not equal */
       {
          if(!gen.z) _bcc_jmpt();
          else _bcc_jmpf();
          return 1;
       }
       case 7: /* equal */
       {
          if(gen.z) _bcc_jmpt();
          else _bcc_jmpf();
          return 1;
       }
       case 10: /* plus */
       {
         if(!gen.n) _bcc_jmpt();
         else _bcc_jmpf();
         return 1;
       }
       case 11: /* minus */
       {
          if(gen.n) _bcc_jmpt();
          else _bcc_jmpf();
          return 1;
       }
   }
   return 0;
}



int _lea(void)
{
      get_ea(pipeline.b4ea.mode,pipeline.b4ea.reg1,2,0);
      gen.a[pipeline.b4ea.reg]=eaddy;
      return 1;
}

int _movem(void)
{
   unsigned short int rol;
   unsigned short int hm;
   unsigned long addy;
   if(pipeline.b5.dr)
   {
     get_ea(pipeline.b5.mode,pipeline.b5.reg,0,0);
     addy=eaddy;
     rol=read_word(gen.pc+2);
     opdsp+=2;
     for(hm=0;hm<16;hm++)
     {
           if(rol & 1)
           {
                if(pipeline.b5.size)
                {  /* read long */
                     if(hm>7) gen.a[hm-8]=read_long(addy);
                     else gen.d[hm]=read_long(addy);
                     addy+=4;
                }
                else
                {
                     if(hm>7) gen.a[hm-8]=read_word(addy);
                     else gen.d[hm]=read_word(addy);
                     addy+=2;
                
                }
           }
           rol=rol>>1;
     }
     return 1;
   }
   return 0;
}

int _nop(void)
{
   return 1;
}

int _move(void)
{
   register int x;
   printf("move[%08x]\n{\n",gen.pc);
   x=get_ea(pipeline.b2.smode,pipeline.b2.sreg,pipeline.b2.size,0);
   put_ea(pipeline.b2.dmode,pipeline.b2.dreg,pipeline.b2.size,x,0);
   printf("}\n");
   return 1;
      
}
int _andi(void)
{
   long int x,y,o;
   gen.v=0;
   gen.c=0;
   
   x=get_ea(7,4,pipeline.b8.size,0); 
   o=opdsp;
   y=get_ea(pipeline.b8.mode,pipeline.b8.reg,pipeline.b8.size,0);
   opdsp=o;
   y=x && y;
   put_ea(pipeline.b8.mode,pipeline.b8.reg,pipeline.b8.size,y,0); 

   if(y == 0) gen.z=1;
   else gen.z=0;

   if(y > nego(pipeline.b8.size)) gen.n=1;
   else gen.n=0;
   
   return 1;
}