#include "main.h"
#include "genux.h"
#include "m68000.h"


unsigned char *gen_ram;

unsigned int busM68000(unsigned char d,unsigned char size,unsigned long int address,unsigned long int data)
{
   if(address>0xfffffb) return 0;
   switch(d)
   {
       case 0:  /*read*/
       {
           switch(size)
           {
                case 0: /* byte */
                      return gen_ram[address];
         
                case 1: /* word */
                      return (( (unsigned long int) gen_ram[address  ] << 8)+
                                             gen_ram[address+1]     );

                case 2: /* long */
                      return (( (unsigned long int) gen_ram[address  ] << 24)+
                      (  (unsigned long int) gen_ram[address+1] << 16)+
                      (  (unsigned long int) gen_ram[address+2] << 8 )+
                                             gen_ram[address+3]      );
                                               

           }
        break;
       }
       
       case 1:
       {
           switch(size)
           {
                case 0: /*byte*/
                {
                   gen_ram[address]=(data%256);
                   return 1;
                }
                case 1: /*word*/
                {
                   gen_ram[address]=(data%65536)/256;
                   gen_ram[address+1]=(data%65536)%256;
                   return 1;
                }
                case 2: /*long*/
                {
                   gen_ram[address]=(data/16777216);
                   gen_ram[address+1]=(data%16777216)/65536;
                   gen_ram[address+2]=((data%16777216)%65536)/256;
                   gen_ram[address+3]=((data%16777216)%65536)%256;
                }                                                                           
           }
       }
    }
}

int businit(void)
{
  printf("  Allocating RAM...");
    if( (gen_ram = (char *) malloc(0xffffff)) == NULL)
    {
         printf("Failed.\n");
         wedie(NO_RAM);
     }
     else printf("Done.\n");
  printf("  Linking ram to 68000\n");
  m68000.bus=busM68000;

}
