#include <stdio.h>
#include "genux.h"
#include "m68000.h"
#include "bus.h"

int pargc;
char pargv[7][30];
char beef[1024];
extern int run68k(void);

unsigned int dmlst;
    
void dumpregs(void){
   char rawname[8];
   m68000.getopname(rawname,((genst*)m68000.regs)->pc);
   printf("  Executed %i cycles total (this virtual second).\n",((genst*)m68000.regs)->cycles);
   printf("  D[0]:%08X D[1]:%08X D[2]:%08X D[3]:%08X\n",
         ((genst*)m68000.regs)->d[0],
         ((genst*)m68000.regs)->d[1],
         ((genst*)m68000.regs)->d[2],
         ((genst*)m68000.regs)->d[3]);
   printf("  D[4]:%08X D[5]:%08X D[6]:%08X D[7]:%08X\n",
         ((genst*)m68000.regs)->d[4],
         ((genst*)m68000.regs)->d[5],
         ((genst*)m68000.regs)->d[6],
         ((genst*)m68000.regs)->d[7]);
   printf("  A[0]:%08X A[1]:%08X A[2]:%08X A[3]:%08X\n",
         ((genst*)m68000.regs)->a[0],
         ((genst*)m68000.regs)->a[1],
         ((genst*)m68000.regs)->a[2],
         ((genst*)m68000.regs)->a[3]);
   printf("  A[4]:%08X A[5]:%08X A[6]:%08X A[7]:%08X\n",
         ((genst*)m68000.regs)->a[4],
         ((genst*)m68000.regs)->a[5],
         ((genst*)m68000.regs)->a[6],
         ((genst*)m68000.regs)->a[7]);
   printf("  PC:%08X->%04X  %-029s(%c%c%c%c%c)\n",
     ((genst*)m68000.regs)->pc,M68000read_word(((genst*)m68000.regs)->pc),
     rawname,
     'X' | (char) ((!((genst*)m68000.regs)->x) << 5),
     'N' | (char) ((!((genst*)m68000.regs)->n) << 5),
     'Z' | (char) ((!((genst*)m68000.regs)->z) << 5),
     'V' | (char) ((!((genst*)m68000.regs)->v) << 5),
     'C' | (char) ((!((genst*)m68000.regs)->c) << 5));
}

void putschar(unsigned char defa)
{
    if((defa<32) || (defa>126) ) putchar('.');
    else putchar(defa);
}

int parsarg()
{
     int x,y,z;
     y=0;
     z=0;
     memset(pargv,0,sizeof(pargv));
     pargv[0][0]=beef[0];
     
     for(x=1;x<1024;x++)
     {
         switch(beef[x])
         {
             case ' ':
             case ',':
             case ':':
             {
               z=0;
               break;
             }
             case '\0':
             case '\n':
                 return y+1;
             default:
             {    
                if(z==0) y++;
                pargv[y][z++] = beef[x];
             }
         } 
     
     
     }
}

void dumpb(unsigned int addy,int lena)
{    
     int cnt1,cnt2;
     for(cnt1=0;cnt1<lena;cnt1++)
     {
        printf("%08x: ",addy+(cnt1*16));          
        for(cnt2=0;cnt2<16;cnt2++)
        {
            printf("%02x",M68000read_byte(addy+(cnt1*16)+cnt2));
            if(cnt2==7) putchar('-');
            else putchar(' ');
        }
        printf("  ");
        for(cnt2=0;cnt2<16;cnt2++)
            putschar(M68000read_byte(addy+(cnt1*16)+cnt2));
        putchar('\n');
     }
     dmlst=addy+(lena*16);
     

}

debug_68k()
{
    int trig,trig2;
    int teo;
    printf("Debugging mode for the 68k chip\n");
    trig=1;
    trig2=1;
    dmlst=((genst*)m68000.regs)->pc;
    printf("[68000]\n");
    dumpregs();
    while(trig)
    {
       if(!trig2)
       {
          printf("Unknown opcode, major error...\n");
          trig2=1;
       }
       putchar('-');
       fgets(beef,1024, stdin);
       pargc = parsarg();
       switch(beef[0])
       {
          case 'h':
          case '?':
          {
               printf("h/?    help......:displays help\n");
               printf("t/p/n  trace.....:traces a single instruction\n");
               printf("g      go........:starts endless execution until error\n");
               printf("r      registers.:displays registers\n");
               printf("d      dump......:dumps the memory\n");
               printf("q      quit......:ends the debugger\n");
               printf("s      signal....:signals the cpu (0=reset)\n"); 
               break;          
          }
          case 'p':
          case 't':
          case 'n':
          {
             if(pargc>1) ((genst*)m68000.regs)->pc=strtol(pargv[1],NULL,16);
             if(pargc>2) 
             {
                 teo=strtol(pargv[2],NULL,16);
                 for(;teo;teo--)
                 {
                       trig2=run68k();
                       if(!trig2) break;
                       else dumpregs();

                       printf("-n %08x %x\n",((genst*)m68000.regs)->pc,teo);            
                       
                 }
             } 
             else
             {
                 if(trig2=run68k())
                   dumpregs();
             }
             break;
          }
          case 's':
          {
               int ca;
               ca=0;
               if(pargc>1) ca=strtol(pargv[1],NULL,16);          
               switch(ca)
               {
                   case 0:
                   {
                      printf("resetting cpu\n");
                      reset_68k();
                      dumpregs();
                      break;
                   }
                   default:
                   {
                       printf("unknown signal\n");
                       break;
                   }
               }
               break;
          }
          case 'q':
          {
              trig=0;
              break;
          }
          case 'r':
          {
              dumpregs();
              break;
          }
          case 'g':
          {
              if(pargc>1) ((genst*)m68000.regs)->pc=strtol(pargv[1],NULL,16);
              while(m68000.step());
              printf("Crashed\n");
              dumpregs();
              break;
          }
          case 'd':
          {
              
              switch(pargc)
              {
                 case 1:
                 {
                    dumpb(dmlst,8);
                    break;
                 }
                 case 2:
                 {
                    dumpb(strtol(pargv[1],NULL,16),8);
                    break;                 
                 }
              }
              break;
          }
       }
    }   
}