#include "main.h"
#include "m68000.h"

extern int load_cart(char *filename);

char *myself;
switches genux;
extern unsigned char *gen_ram;

int wedie(short int level){
  printf("Emulation stopped\n");
  printf("Destructing SEGA\n");
  free(gen_ram);
  exit(level);
}

void sig(void)
{
   printf("Genux v%s The linux Sega Genesis Emulator\n",GENVER);
   printf("(c) 1997-98 by James Seter (Pharos@DAL.net)\n\n");

}

void syntax(void)
{
   printf("     USEAGE: %s [options] romfile\n",myself);
   printf("\n-t   Dump debuging genux.bin of the romfile\n");
   printf("-d   Debug the 68000 chip\n");
   printf("-x   Pre Compile m68000 cpu\n");
   printf("\nRom images include *.bin, and *.smd and compressed files with a .gz extention\n");
   printf("if the rom is not found in ./ then it looks for it in ./roms\n");
   exit(1);
}

void cram(void)
{
  printf("  Allocating RAM...");
    if( (gen_ram = (char *) malloc(0xffffff)) == NULL)
    {
         printf("Failed.\n");
         wedie(NO_RAM);
     }
     else printf("Done.\n");
}
int parsec(int argc,char **argv){
    int cnt;
    for(cnt=1; cnt < argc; cnt++)
    {
         if( argv[cnt][0] != '-') return cnt;
         switch(argv[cnt][1])
         {
             case 't':
             case 'T':
             {
               /* dump a .bin */
               genux.t=1;
               break;   
             }
             case 'd':
             case 'D':
             {
               /* debugger */
               genux.d=1;
               break;
             }
             case 'x':
             case 'X':
             {
             
               if(m68000.message(COMPILE_CORE))
                 wedie(13);
               break;
             }
             default:
             {
                 printf("%s: Unknown option '%c'\n",myself, argv[cnt][1]);
                 wedie(BAD_OPTION);
             }
         
         }
    }
    return 0;

}
int run68k(void)
{
    int id;
    id=m68000.step();
    if( ((genst*)m68000.regs)->cycles >= 480000000) ((genst*)m68000.regs)->cycles = 0; /* 8mhz */
    return id;
}



void boot_68k(void)
{
   while(run68k());
   dumpregs();
}
            


int main(int argc,char **argv)
{
    char rom;
    myself=argv[0];
    sig();
    if(argc < 2) syntax();
    if((rom = parsec(argc, argv)) == 0 ) syntax();
    
    businit();
    if( load_cart(argv[rom]) )
    {
        printf("ROM error, file not found or invalid!!!\n");
        wedie(BAD_CART);
    }
    printf("  68000 installed\n");
    printf("  68000 reset...");
    if(m68000.reset()) printf("done.\n");
    else
    {
         printf("Failed.\n");
         wedie(9);
    }
    if(genux.d) debug_68k();
    else boot_68k();
    exit(0);
}    